import scala.actors._

class Counter extends Actor {
  var visitors : Int = 0
  var quit     : Int = 0
  def act() {
    while (quit != 2) {
      receive {
        case ("increment", name) =>
          visitors += 1
          println("increment " + visitors + " from " + name)
        case "quit" =>
          quit += 1
      }
    }
    println("Final Count: " + visitors)
  }
}

class Turnstile(n: String, c : Counter) extends Actor {
  val name    : String = n
  val counter : Counter = c
  def act() {
    for (i <- 1 to 20) {
      counter ! ("increment", name)
    }
    counter ! "quit"
  }
}

object Garden {
  def main(args: Array[String]) {
    val c    = new Counter
    val east = new Turnstile("east", c)
    val west = new Turnstile("west", c)

    c.start()
    east.start()
    west.start()
  }
}
